diff --git a/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelDispatcher.java b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelDispatcher.java
index a7c79b435..20241c95e 100644
--- a/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelDispatcher.java
+++ b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelDispatcher.java
@@ -269,6 +269,7 @@ public class ItemModelDispatcher extends Dispatcher<Item, ItemModel> {
             .setDisplayPos(DisplayPos.THIRD_PERSON_RIGHT_HAND, HANDHELD_ROD_THIRD_PERSON_RIGHT_HAND)
             .setDisplayPos(DisplayPos.THIRD_PERSON_LEFT_HAND, HANDHELD_ROD_THIRD_PERSON_LEFT_HAND));
         addDispatch(new ItemModelStandard(Items.TOOL_CLOCK, "minecraft"));
+        addDispatch(new ItemModelBlock((ItemBlock<?>) Blocks.GLOWSTONE.asItem()).setFullBright());
         addDispatch(new ItemModelStandard(Items.DUST_GLOWSTONE, "minecraft").setFullBright());
         addDispatch(new ItemModelStandard(Items.FOOD_FISH_RAW, "minecraft"));
         addDispatch(new ItemModelStandard(Items.FOOD_FISH_COOKED, "minecraft"));
@@ -358,6 +359,11 @@ public class ItemModelDispatcher extends Dispatcher<Item, ItemModel> {
         addDispatch(new ItemModelStandard(Items.LANTERN_FIREFLY_ORANGE, "minecraft").setFullBright());
         addDispatch(new ItemModelStandard(Items.LANTERN_FIREFLY_RED, "minecraft").setFullBright());
 
+        addDispatch(new ItemModelBlock((ItemBlock<?>) Blocks.LAMP_ACTIVE.asItem()).setFullBright());
+        addDispatch(new ItemModelBlock((ItemBlock<?>) Blocks.LAMP_IDLE.asItem()).setFullBright());
+        addDispatch(new ItemModelBlock((ItemBlock<?>) Blocks.LAMP_INVERTED_ACTIVE.asItem()).setFullBright());
+        addDispatch(new ItemModelBlock((ItemBlock<?>) Blocks.LAMP_INVERTED_IDLE.asItem()).setFullBright());
+
         addDispatch(new ItemModelStandard(Items.BASKET, "minecraft"));
         addDispatch(new ItemModelStandard(Items.FLAG, "minecraft")
             .setDisplayPos(DisplayPos.FIRST_PERSON_RIGHT_HAND, HANDHELD_FIRST_PERSON_RIGHT_HAND)
@@ -427,8 +433,15 @@ public class ItemModelDispatcher extends Dispatcher<Item, ItemModel> {
 
         addDispatch(new ItemModelStandard(Items.FOOD_VENISON_RAW, "minecraft"));
         addDispatch(new ItemModelStandard(Items.FOOD_VENISON_COOKED, "minecraft"));
-//        addDispatch(new ItemModelStandard(Items.RUBYGLASS_DUST, "minecraft"));
-        addDispatch(new ItemModelStandard(Items.RUBYGLASS_CRYSTAL, "minecraft"));
+
+        addDispatch(new ItemModelStandard(Items.RUBYGLASS, "minecraft").setFullBright());
+        addDispatch(new ItemModelBlock((ItemBlock<?>) Blocks.RUBYGLASS_COLUMN.asItem()).setFullBright());
+        addDispatch(new ItemModelBlock((ItemBlock<?>) Blocks.BLOCK_RUBYGLASS.asItem()).setFullBright());
+        addDispatch(new ItemModelBlock((ItemBlock<?>) Blocks.RUBYGLASS_GROWTH.asItem()).setFullBright());
+        addDispatch(new ItemModelBlock((ItemBlock<?>) Blocks.RUBYGLASS_CRYSTAL.asItem()).setFullBright());
+
+        addDispatch(new ItemModelBlock((ItemBlock<?>) Blocks.BOULDER_MAGMATIC.asItem()));
+        addDispatch(new ItemModelBlock((ItemBlock<?>) Blocks.BOULDER_SULFURIC.asItem()));
 
         addDispatch(new ItemModelStandard(Items.DOUGH, "minecraft"));
 
@@ -439,6 +452,15 @@ public class ItemModelDispatcher extends Dispatcher<Item, ItemModel> {
         addDispatch(new ItemModelStandard(Items.ARMOR_WOLF_GOLD, "minecraft"));
         addDispatch(new ItemModelStandard(Items.ARMOR_WOLF_STEEL, "minecraft"));
 
+        addDispatch(new ItemModelStandard(Items.AMMO_ARROW_FLAMING, "minecraft"));
+
+        addDispatch(new ItemModelStandard(Items.SULFUR, "minecraft"));
+
+        addDispatch(new ItemModelStandard(Items.STATUE_GLOOMSTONE, "minecraft"));
+        addDispatch(new ItemModelStandard(Items.STATUE_NETHERRACK, "minecraft"));
+        addDispatch(new ItemModelStandard(Items.STATUE_PERMAFROST, "minecraft"));
+        addDispatch(new ItemModelStandard(Items.STATUE_SLATE, "minecraft"));
+
         for (int i = 0; i < Blocks.blocksList.length; i++) {
             if (Blocks.blocksList[i] == null) continue;
             Item item = Blocks.blocksList[i].asItem();
diff --git a/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelStandard.java b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelStandard.java
index bc60db4a4..7789cc5ab 100644
--- a/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelStandard.java
+++ b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelStandard.java
@@ -1,5 +1,6 @@
 package net.minecraft.client.render.item.model;
 
+import net.minecraft.client.Minecraft;
 import net.minecraft.client.render.TextureManager;
 import net.minecraft.client.render.font.FontRenderer;
 import net.minecraft.client.render.renderer.BlendFactor;
@@ -216,8 +217,20 @@ public class ItemModelStandard extends ItemModel{
             GLRenderer.pushFrame();
             GLRenderer.disableState(State.DEPTH_TEST);
             GLRenderer.setShader(Shaders.COLOR);
-            final int colorFG = Color.HSBtoRGB(progress / 255F / 3F, 1f, 1f);
-            final int colorBG = (0xFF - progress) / 4 << 16 | 0x3f00;
+
+            final Minecraft mc = Minecraft.getMinecraft();
+            final boolean isAcidic = mc.thePlayer != null && mc.thePlayer.shouldShowAcidVisualEffects() && mc.thePlayer.getGamemode().hasToolDurability();
+            final int colorFG;
+            final int colorBG;
+            if (isAcidic) {
+                final float t = progress / 255F;
+                colorFG = Color.HSBtoRGB(0.11F + t * 0.06F, 1f, 1f);
+                colorBG = Color.HSBtoRGB(0.11F, 1f, 0.35f);
+            } else {
+                colorFG = Color.HSBtoRGB(progress / 255F / 3F, 1f, 1f);
+                colorBG = (0xFF - progress) / 4 << 16 | 0x3f00;
+            }
+
             tessellator.startDrawingQuads();
             renderColoredQuad(tessellator, x + 2, y + 13, 13, 2, 0, a);
             renderColoredQuad(tessellator, x + 2, y + 13, 12, 1, colorBG, a);
diff --git a/game/client/src/main/java/net/minecraft/client/render/particle/Particle.java b/game/client/src/main/java/net/minecraft/client/render/particle/Particle.java
index 66f7294e6..4410a5f79 100644
--- a/game/client/src/main/java/net/minecraft/client/render/particle/Particle.java
+++ b/game/client/src/main/java/net/minecraft/client/render/particle/Particle.java
@@ -1,28 +1,20 @@
 package net.minecraft.client.render.particle;
 
-import it.unimi.dsi.fastutil.objects.ObjectArrayList;
 import net.minecraft.client.render.ParticleEngine;
 import net.minecraft.client.render.tessellator.TessellatorParticle;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.core.Global;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.BlockLogicMesh;
-import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.LightIndexHelper;
 import net.minecraft.core.util.helper.MathHelper;
-import net.minecraft.core.util.phys.HitResult;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.pos.TilePos;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 import org.joml.Random;
-import org.joml.Vector2d;
-import org.joml.Vector3d;
-import org.joml.primitives.AABBd;
 import org.joml.primitives.AABBdc;
-import org.joml.primitives.Rayd;
 
-import java.util.List;
+import java.util.concurrent.ThreadLocalRandom;
 
 /**
  * Displays a small, temporary texture in the world, used as a visual effect. Managed by {@link ParticleEngine}.
@@ -34,7 +26,7 @@ public class Particle {
     protected float vo;
     protected int age;
     protected int lifetime;
-    protected float size;
+    public float size;
     protected float gravity;
     protected float rCol;
     protected float gCol;
@@ -51,11 +43,17 @@ public class Particle {
     public double yd = 0;
     public double zd = 0;
 
+    protected int bX = Integer.MAX_VALUE;
+    protected int bY = Integer.MAX_VALUE;
+    protected int bZ = Integer.MAX_VALUE;
+
     public boolean noPhysics = false;
     public boolean onGround = false;
     public boolean removed = false;
 
-    public final @NotNull World world;
+    private final TilePos qPos = new TilePos();
+
+    public @NotNull World world;
 
     /**
      * Creates a new Particle.
@@ -74,10 +72,33 @@ public class Particle {
         this.y = y;
         this.z = z;
         this.rCol = this.gCol = this.bCol = 1.0F;
-        this.xd = xa + (float) (Math.random() * 2D - 1.0D) * 0.4F;
-        this.yd = ya + (float) (Math.random() * 2D - 1.0D) * 0.4F;
-        this.zd = za + (float) (Math.random() * 2D - 1.0D) * 0.4F;
-        float speed = (float) (Math.random() + Math.random() + 1.0D) * 0.15F;
+        ThreadLocalRandom tlr = ThreadLocalRandom.current();
+        this.xd = xa + (float) (tlr.nextDouble() * 2D - 1.0D) * 0.4F;
+        this.yd = ya + (float) (tlr.nextDouble() * 2D - 1.0D) * 0.4F;
+        this.zd = za + (float) (tlr.nextDouble() * 2D - 1.0D) * 0.4F;
+        float speed = (float) (tlr.nextDouble() + tlr.nextDouble() + 1.0D) * 0.15F;
+        float dd = MathHelper.sqrt(this.xd * this.xd + this.yd * this.yd + this.zd * this.zd);
+        this.xd = (this.xd / dd) * speed * 0.4D;
+        this.yd = (this.yd / dd) * speed * 0.4D + 0.1D;
+        this.zd = (this.zd / dd) * speed * 0.4D;
+        this.uo = random.nextFloat() * 3F;
+        this.vo = random.nextFloat() * 3F;
+        this.size = (random.nextFloat() * 0.5F + 0.5F) * 2.0F;
+        this.lifetime = (int) (4F / (random.nextFloat() * 0.9F + 0.1F));
+        this.age = 0;
+    }
+
+    public Particle resetBase(@NotNull World world, double x, double y, double z, double xa, double ya, double za) {
+        this.world = world;
+        this.x = x;
+        this.y = y;
+        this.z = z;
+        this.rCol = this.gCol = this.bCol = 1.0F;
+        ThreadLocalRandom tlr = ThreadLocalRandom.current();
+        this.xd = xa + (float) (tlr.nextDouble() * 2D - 1.0D) * 0.4F;
+        this.yd = ya + (float) (tlr.nextDouble() * 2D - 1.0D) * 0.4F;
+        this.zd = za + (float) (tlr.nextDouble() * 2D - 1.0D) * 0.4F;
+        float speed = (float) (tlr.nextDouble() + tlr.nextDouble() + 1.0D) * 0.15F;
         float dd = MathHelper.sqrt(this.xd * this.xd + this.yd * this.yd + this.zd * this.zd);
         this.xd = (this.xd / dd) * speed * 0.4D;
         this.yd = (this.yd / dd) * speed * 0.4D + 0.1D;
@@ -87,6 +108,11 @@ public class Particle {
         this.size = (random.nextFloat() * 0.5F + 0.5F) * 2.0F;
         this.lifetime = (int) (4F / (random.nextFloat() * 0.9F + 0.1F));
         this.age = 0;
+
+        this.removed = false;
+        this.noPhysics = false;
+        this.onGround = false;
+        return this;
     }
 
     public void init() {
@@ -119,169 +145,146 @@ public class Particle {
     }
 
     public void tick() {
-        this.cachedLightmapCoord = calcLightIndex(1f);
+        int cX = MathHelper.floor(this.x);
+        int cY = MathHelper.floor(this.y);
+        int cZ = MathHelper.floor(this.z);
+
+        if (cX != this.bX || cY != this.bY || cZ != this.bZ) {
+            this.bX = cX;
+            this.bY = cY;
+            this.bZ = cZ;
+            this.cachedLightmapCoord = calcLightIndex(1f);
+        }
+
         this.xo = this.x;
         this.yo = this.y;
         this.zo = this.z;
+
         if (this.age++ >= this.lifetime) {
             remove();
         }
+
         this.yd -= 0.04D * this.gravity;
+
         move(this.xd, this.yd, this.zd);
+
         this.xd *= 0.98D;
         this.yd *= 0.98D;
         this.zd *= 0.98D;
-        if (this.onGround) {
-            this.xd *= 0.7D;
-            this.zd *= 0.7D;
-        }
     }
 
-    public void move(double xd, double yd, double zd) {
+    public void move(double dx, double dy, double dz) {
         if (this.noPhysics) {
-            this.onGround = false;
-            this.x += xd;
-            this.y += yd;
-            this.z += zd;
+            this.x += dx;
+            this.y += dy;
+            this.z += dz;
             return;
         }
-        HitResult hitResult = raycastBlocks(this.x, this.y, this.z, xd, yd, zd);
-        if (hitResult instanceof HitResult.Tile hitTile) {
-            switch (hitTile.side) {
-                case EAST:
-                case WEST: {
-                    this.x = hitTile.location.x() + hitTile.side.offsetX() * 0.1d * this.size;
-                    this.y += yd;
-                    this.z += zd;
-                    this.xd = 0;
-                    break;
-                }
-                case TOP:
+
+        double buffer = 0.001D;
+
+        // Y-Axis
+        if (dy != 0) {
+            this.qPos.set(MathHelper.floor(this.x), MathHelper.floor(this.y + dy), MathHelper.floor(this.z));
+            AABBdc bb = getCollisionBox(this.qPos);
+
+            boolean collided = false;
+            if (bb != null && this.x >= bb.minX() && this.x <= bb.maxX() && this.z >= bb.minZ() && this.z <= bb.maxZ()) {
+                if (dy < 0 && this.y >= bb.maxY() && this.y + dy <= bb.maxY()) {
                     this.onGround = true;
-                case BOTTOM: {
-                    this.x += xd;
-                    this.y = hitTile.location.y() + hitTile.side.offsetY() * 0.1d * this.size;
-                    this.z += zd;
+                    this.y = bb.maxY() + buffer;
+                    this.xd = 0;
+                    this.zd = 0;
                     this.yd = 0;
-                    break;
+                    collided = true;
                 }
-                case SOUTH:
-                case NORTH: {
-                    this.x += xd;
-                    this.y += yd;
-                    this.z = hitTile.location.z() + hitTile.side.offsetZ() * 0.1d * this.size;
-                    this.zd = 0;
-                    break;
+                else if (dy > 0 && this.y <= bb.minY() && this.y + dy >= bb.minY()) {
+                    this.y = bb.minY() - buffer;
+                    this.yd = 0;
+                    collided = true;
                 }
             }
-        } else {
-            this.x += xd;
-            this.y += yd;
-            this.z += zd;
+
+            if (!collided) {
+                this.y += dy;
+                if (dy < 0) this.onGround = false;
+            }
         }
-    }
 
-    private final Vector2d __r = new Vector2d();
-    private final Rayd __ray = new Rayd();
-    private final List<AABBdc> aabbs = new ObjectArrayList<>();
-    private final AABBd refAABB = new AABBd();
-
-    public @Nullable HitResult raycastBlocks(final double ox, final double oy, final double oz, final double xd, final double yd, final double zd) {
-        this.__ray.oX = ox;
-        this.__ray.oY = oy;
-        this.__ray.oZ = oz;
-        double length = org.joml.Math.sqrt(xd * xd + yd * yd + zd * zd);
-        if (length <= 0) return null;
-        this.__ray.dX = (xd / length);
-        this.__ray.dY = (yd / length);
-        this.__ray.dZ = (zd / length);
-        Rayd ray = this.__ray;
-
-        final double maxT = length; // how many 1 block steps
-        final double dDistX = ray.dX == 0 ? Double.MAX_VALUE : org.joml.Math.abs(1 / ray.dX);
-        final double dDistY = ray.dY == 0 ? Double.MAX_VALUE : org.joml.Math.abs(1 / ray.dY);
-        final double dDistZ = ray.dZ == 0 ? Double.MAX_VALUE : org.joml.Math.abs(1 / ray.dZ);
-
-        final int signX = (int) org.joml.Math.signum(ray.dX);
-        final int signY = (int) org.joml.Math.signum(ray.dY);
-        final int signZ = (int) org.joml.Math.signum(ray.dZ);
-
-        TilePos qPos = new TilePos();
-        TilePos tilePos = new TilePos(ray.oX, ray.oY, ray.oZ);
-
-        double sideDistX = -(ray.oX - (tilePos.x + 0.5)) * (1 / ray.dX) + 0.5 * dDistX;
-        double sideDistY = -(ray.oY - (tilePos.y + 0.5)) * (1 / ray.dY) + 0.5 * dDistY;
-        double sideDistZ = -(ray.oZ - (tilePos.z + 0.5)) * (1 / ray.dZ) + 0.5 * dDistZ;
-
-        double dx = 0.0;
-        double dy = 0.0;
-        double dz = 0.0;
-
-        Direction direction = Direction.NONE;
-        while (dx * dx + dy * dy + dz * dz < length * length + 4) {
-            this.aabbs.clear();
-            for (int _x = -1; _x <= 1; _x++) {
-                for (int _y = -1; _y <= 1; _y++) {
-                    for (int _z = -1; _z <= 1; _z++) {
-                        Block<?> block = this.world.getBlockType(tilePos.add(_x, _y, _z, qPos));
-                        if (collidesWithBlock(block, this.world.getBlockData(qPos))) {
-                            block.getCollisionAABBs(this.world, qPos, this.refAABB.setMin(qPos.x, qPos.y, qPos.z).setMax(qPos.x + 1, qPos.y + 1, qPos.z + 1), this.aabbs);
-                        }
-                    }
+        // X-Axis
+        if (dx != 0) {
+            this.qPos.set(MathHelper.floor(this.x + dx), MathHelper.floor(this.y), MathHelper.floor(this.z));
+            AABBdc bb = getCollisionBox(this.qPos);
+
+            boolean collided = false;
+            if (bb != null && this.y >= bb.minY() && this.y <= bb.maxY() && this.z >= bb.minZ() && this.z <= bb.maxZ()) {
+                if (dx < 0 && this.x >= bb.maxX() && this.x + dx <= bb.maxX()) {
+                    this.x = bb.maxX() + buffer;
+                    this.xd *= -0.3D;
+                    collided = true;
+                } else if (dx > 0 && this.x <= bb.minX() && this.x + dx >= bb.minX()) {
+                    this.x = bb.minX() - buffer;
+                    this.xd *= -0.3D;
+                    collided = true;
                 }
             }
-            if (!this.aabbs.isEmpty()) {
-                double tMin = Double.MAX_VALUE;
-                for (int i = 0, aabbsSize = this.aabbs.size(); i < aabbsSize; i++) {
-                    if (this.aabbs.get(i).intersectsRay(ray, this.__r)) {
-                        tMin = org.joml.Math.min(this.__r.x, tMin);
-                    }
-                }
-                if (tMin < maxT) {
-                    return new HitResult.Tile(
-                        tilePos,
-                        direction.side(),
-                        new Vector3d(ray.oX + tMin * ray.dX, ray.oY + tMin * ray.dY, ray.oZ + tMin * ray.dZ));
+
+            if (!collided) {
+                this.x += dx;
+            }
+        }
+
+        // Z-Axis
+        if (dz != 0) {
+            this.qPos.set(MathHelper.floor(this.x), MathHelper.floor(this.y), MathHelper.floor(this.z + dz));
+            AABBdc bb = getCollisionBox(this.qPos);
+
+            boolean collided = false;
+            if (bb != null && this.x >= bb.minX() && this.x <= bb.maxX() && this.y >= bb.minY() && this.y <= bb.maxY()) {
+                if (dz < 0 && this.z >= bb.maxZ() && this.z + dz <= bb.maxZ()) {
+                    this.z = bb.maxZ() + buffer;
+                    this.zd *= -0.3D;
+                    collided = true;
+                } else if (dz > 0 && this.z <= bb.minZ() && this.z + dz >= bb.minZ()) {
+                    this.z = bb.minZ() - buffer;
+                    this.zd *= -0.3D;
+                    collided = true;
                 }
             }
 
-            if (Double.isFinite(sideDistX) && sideDistX < sideDistY && sideDistX < sideDistZ) {
-                tilePos.x += signX;
-                dx = tilePos.x - ray.oX;
-                sideDistX += dDistX;
-                direction = signX > 0 ? Direction.WEST : Direction.EAST;
-            } else if (Double.isFinite(sideDistY) && sideDistY < sideDistZ) {
-                tilePos.y += signY;
-                dy = tilePos.y - ray.oY;
-                sideDistY += dDistY;
-                direction = signY > 0 ? Direction.DOWN : Direction.UP;
-            } else if (Double.isFinite(sideDistZ)) {
-                tilePos.z += signZ;
-                dz = tilePos.z - ray.oZ;
-                sideDistZ += dDistZ;
-                direction = signZ > 0 ? Direction.NORTH : Direction.SOUTH;
-            } else {
-                return null;
+            if (!collided) {
+                this.z += dz;
             }
         }
-        return null;
     }
 
-    public boolean collidesWithBlock(@NotNull Block<?> block, int data) {
-        return !Block.hasLogicClass(block, BlockLogicMesh.class);
+    protected @Nullable AABBdc getCollisionBox(TilePos pos) {
+        if (this.world.isAirBlock(pos)) return null;
+
+        Block<?> blk = this.world.getBlockType(pos);
+        if (!blk.getMaterial().blocksMotion()) {
+            return null;
+        }
+
+        AABBdc bb = blk.getLogic().getCollisionAABB(this.world, pos);
+        if (bb != null && bb.isValid()) {
+            return bb;
+        }
+
+        return null;
     }
 
     /**
      * Renders the particle in the world.
      *
-     * @param t           The tessellator to use to draw the particle.
+     * @param tessellatorParticle The tessellator to use to draw the particle.
      * @param partialTick The time since the last tick.
      */
-    public void render(@NotNull TessellatorParticle t, float partialTick) {
+    public void render(@NotNull TessellatorParticle tessellatorParticle, float partialTick) {
         if (this.tex == null) return;
-        t.setLightmapCoord1i(getLightIndex(partialTick));
-        t.setColorOpaque3f(this.rCol, this.gCol, this.bCol);
-        t.addParticle(
+        tessellatorParticle.setLightmapCoord1i(getLightIndex(partialTick));
+        tessellatorParticle.setColorOpaque3f(this.rCol, this.gCol, this.bCol);
+        tessellatorParticle.addParticle(
             MathHelper.lerp(this.xo, this.x, partialTick),
             MathHelper.lerp(this.yo, this.y, partialTick),
             MathHelper.lerp(this.zo, this.z, partialTick),
@@ -298,16 +301,19 @@ public class Particle {
         return ParticleEngine.WORLD_TEXTURE;
     }
 
-    public float calcBrightness(float partialTick) {
+    public float calcBrightness(float pt) {
         if (Global.accessor.isFullbrightEnabled()) {
             return 1.0f;
         }
-        TilePos pos = new TilePos(
-            MathHelper.lerp(this.xo, this.x, partialTick),
-            MathHelper.lerp(this.yo, this.y, partialTick),
-            MathHelper.lerp(this.zo, this.z, partialTick));
-        if (this.world.areBlocksLoaded(pos, pos)) {
-            return this.world.getLightBrightness(pos);
+
+        this.qPos.set(
+            MathHelper.floor(MathHelper.lerp(this.xo, this.x, pt)),
+            MathHelper.floor(MathHelper.lerp(this.yo, this.y, pt)),
+            MathHelper.floor(MathHelper.lerp(this.zo, this.z, pt))
+        );
+
+        if (this.world.areBlocksLoaded(this.qPos, this.qPos)) {
+            return this.world.getLightBrightness(this.qPos);
         }
         return 0;
     }
@@ -316,27 +322,24 @@ public class Particle {
         return calcBrightness(partialTick);
     }
 
-    public byte calcLightIndex(float partialTick) {
+    public byte calcLightIndex(float pt) {
         if (Global.accessor.isFullbrightEnabled()) return LightIndexHelper.lightIndex2i(15, 15);
-        TilePos blockPos = new TilePos(
-            MathHelper.lerp(this.xo, this.x, partialTick),
-            MathHelper.lerp(this.yo, this.y, partialTick),
-            MathHelper.lerp(this.zo, this.z, partialTick));
-
-        byte lightIndex = 0;
-        if (this.world.getBlockLitInteriorSurface(blockPos)) {
-            TilePos queryPos = new TilePos();
-
-            lightIndex = LightIndexHelper.max(lightIndex, this.world.getSavedLightIndex(blockPos.up(queryPos)));
-            lightIndex = LightIndexHelper.max(lightIndex, this.world.getSavedLightIndex(blockPos.west(queryPos)));
-            lightIndex = LightIndexHelper.max(lightIndex, this.world.getSavedLightIndex(blockPos.east(queryPos)));
-            lightIndex = LightIndexHelper.max(lightIndex, this.world.getSavedLightIndex(blockPos.south(queryPos)));
-            lightIndex = LightIndexHelper.max(lightIndex, this.world.getSavedLightIndex(blockPos.north(queryPos)));
-        } else {
-            lightIndex = this.world.getSavedLightIndex(blockPos);
+
+        int bX = MathHelper.floor(MathHelper.lerp(this.xo, this.x, pt));
+        int bY = MathHelper.floor(MathHelper.lerp(this.yo, this.y, pt));
+        int bZ = MathHelper.floor(MathHelper.lerp(this.zo, this.z, pt));
+
+        if (this.world.getBlockLitInteriorSurface(this.qPos.set(bX, bY, bZ))) {
+            byte lIdx = 0;
+            lIdx = LightIndexHelper.max(lIdx, this.world.getSavedLightIndex(this.qPos.set(bX, bY + 1, bZ)));
+            lIdx = LightIndexHelper.max(lIdx, this.world.getSavedLightIndex(this.qPos.set(bX - 1, bY, bZ)));
+            lIdx = LightIndexHelper.max(lIdx, this.world.getSavedLightIndex(this.qPos.set(bX + 1, bY, bZ)));
+            lIdx = LightIndexHelper.max(lIdx, this.world.getSavedLightIndex(this.qPos.set(bX, bY, bZ + 1)));
+            lIdx = LightIndexHelper.max(lIdx, this.world.getSavedLightIndex(this.qPos.set(bX, bY, bZ - 1)));
+            return lIdx;
         }
 
-        return lightIndex;
+        return this.world.getSavedLightIndex(this.qPos.set(bX, bY, bZ));
     }
 
     public byte getLightIndex(float partialTick) {
diff --git a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleAcidBoiling.java b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleAcidBoiling.java
new file mode 100644
index 000000000..131c3a8a2
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleAcidBoiling.java
@@ -0,0 +1,72 @@
+package net.minecraft.client.render.particle;
+
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
+import net.minecraft.core.block.material.Materials;
+import net.minecraft.core.util.helper.MathHelper;
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.pos.TilePos;
+import org.jetbrains.annotations.NotNull;
+
+public class ParticleAcidBoiling extends Particle {
+
+	private float sinTimer = 0.0F;
+	private final boolean isReversed;
+	private final boolean needsWater;
+	private final TilePos qpos = new TilePos();
+	private final @NotNull IconCoordinate popping = TextureRegistry.getTexture("minecraft:particle/acid_boiling_pop");
+
+	public ParticleAcidBoiling(World world, double x, double y, double z, double xa, double ya, double za, boolean needsWater) {
+		super(world, x, y, z, xa, ya, za);
+		this.needsWater = needsWater;
+		this.rCol = 1.0F;
+		this.gCol = 1.0F;
+		this.bCol = 1.0F;
+		this.tex = TextureRegistry.getTexture("minecraft:particle/acid_boiling");
+		this.size *= random.nextFloat() * 0.7F + 0.3F;
+		this.xd = xa * 0.2 + (Math.random() * (double) 2.0F - (double) 1.0F) * (double) 0.02F;
+		this.yd = ya * 0.2 + (Math.random() * (double) 2.0F - (double) 1.0F) * (double) 0.02F;
+		this.zd = za * 0.2 + (Math.random() * (double) 2.0F - (double) 1.0F) * (double) 0.02F;
+		this.lifetime = (int) ((double) 16.0F / (Math.random() * 0.4 + 0.1));
+		this.isReversed = random.nextInt(2) == 0;
+	}
+
+	@Override
+	public void tick() {
+		++this.sinTimer;
+		if (this.sinTimer > 100.0F) {
+			this.sinTimer = 0.0F;
+		}
+
+		this.cachedLightmapCoord = this.calcLightIndex(1.0F);
+		this.xo = this.x;
+		this.yo = this.y;
+		this.zo = this.z;
+		double expand = 0.05;
+		boolean inWater = this.world.getBlockMaterial(this.qpos.set((int) this.x, (int) this.y, (int) this.z)) == Materials.ACID;
+		if (inWater) {
+			this.yd = 0.2;
+			this.xd = MathHelper.sin(this.sinTimer * 0.95F) / 30.0F * (float) (this.isReversed ? -1 : 1);
+			this.zd = MathHelper.cos(this.sinTimer * 0.95F) / 30.0F * (float) (this.isReversed ? -1 : 1);
+		} else {
+			this.yd = MathHelper.clamp(this.yd, -expand, expand);
+		}
+
+		this.move(this.xd, this.yd, this.zd);
+		this.xd *= 0.85;
+		this.yd *= 0.85;
+		this.zd *= 0.85;
+		if (this.needsWater && !inWater) {
+			this.lifetime = MathHelper.clamp(this.lifetime, 0, 8);
+		}
+
+		if (this.lifetime == 6) {
+			this.tex = this.popping;
+			this.world.spawnParticle("arrowtrail", this.x, this.y, this.z, 0.0F, 0.0F, 0.0F, 1, false);
+		} else if (this.lifetime <= 0) {
+			this.remove();
+		}
+
+		--this.lifetime;
+	}
+}
diff --git a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleArrowGolden.java b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleArrowGolden.java
index 7c01c1ae3..dc1c3086e 100644
--- a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleArrowGolden.java
+++ b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleArrowGolden.java
@@ -31,7 +31,7 @@ public class ParticleArrowGolden extends Particle {
     }
 
     @Override
-    public void render(@NotNull TessellatorParticle t, float partialTick) {
+    public void render(@NotNull TessellatorParticle tessellatorParticle, float partialTick) {
         float l = ((this.age + partialTick) / this.lifetime) * 32F;
         if (l < 0.0F) {
             l = 0.0F;
@@ -40,7 +40,7 @@ public class ParticleArrowGolden extends Particle {
             l = 1.0F;
         }
         this.size = this.oSize * l;
-        super.render(t, partialTick);
+        super.render(tessellatorParticle, partialTick);
     }
 
     @Override
